/*
 * Copyright (C) 2013 Olivier Catoni and Thomas Mainguy
 * contact : catoni@noos.fr Thomas.Mainguy@ens.fr
 *
 * This file is part of ToricGrammars : a statistical learning model 
 * for linguistics
 *
 * ToricGrammars is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * ToricGrammars is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include "trees.h"

void TreeNode::addPatterns(TreeNode &patterns, wxString const & starter, int weight) {
	wxString text = read(starter);	
	wxChar const *array = text.c_str();
	size_t textEnd = text.length();
	size_t start, end;
	size_t oStart, oEnd;
	int createPattern;

	start = 0;
	end = TreeNode::first_of(array, start, textEnd, _("\n"));
	while (start < textEnd) { 
		wxString output = starter;
		wxString lastWord;
		oStart = start;
		oEnd = TreeNode::nextTok(array,oStart,end);
		createPattern = 0;
		while( oStart < end) { 
			if (search(array, oStart, oEnd) == 1) { 
				// lastWord << _("#");
				// output << lastWord << _(" ");
				if (createPattern < 1) { 	
					output << lastWord << _("# ");
					createPattern++;
				} else {
					output << wxString(array+oStart, oEnd-oStart);
				}
			} else {
				output << wxString(array+oStart, oEnd-oStart);
				createPattern = 0;
				// lastWord = wxString(array+oStart, oEnd-oStart-1);
			}
			lastWord = wxString(array+oStart, oEnd-oStart-1);
			oStart = oEnd;
			oEnd = TreeNode::nextTok(array, oEnd, end);
		}
		/*
		if (createPattern > 2) { 
			output = starter;
			output << wxString(array+start, end-start);
		}	
		if (createPattern > 0) { 
			remove_all(starter+wxString(array+start, end-start));
		} 
		*/
		patterns.add_all(output,weight);
		start = end + 1;
		end = TreeNode::first_of(array, start, textEnd, _("\n"));
	}
}
